// farzi_jacobian.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include<fstream>
#include<iostream>
#include<kinematic_operations.h>

#define NO 3
#define NC 3
#define NL 7

#define PI 3.14159265
using namespace std;
int _tmain(int argc, _TCHAR* argv[])
{
	
	float E[(NC)];		//the End value of xyz to be achieved neglecting roll, pitch, yaw
	float delE[(NC)];	//th minute motion of hand to be done for small period of time
	float Pos[(NC)];		//curent position coordiantes;

	float Th[NL];
	float delTh[NL];

	float J[NC][NL];		//the jacobian matrix
	float Jpi[NL][NC];	//the pseudoinverse of jacobian matrix

	float gain=0.045;

	int i,j,k;			//counter variables

	/*Reading the final values to achieve*/
	//std::cout<<"Enter the final coordinates to achieve: ";
	for(i=0;i<NC;i++)
		std::cin>>E[i];
	// kinect to printed 
	E[0]=0.5-E[0];
	int hpf_temp=E[1];
	E[1]=E[2]-0.73;
	E[2]=hpf_temp+0.16+0.42;
	//printed to actual
	E[0]=E[0]+0.18;
	E[1]=E[1];
	E[2]=E[2]-0.25;

	Th[0]=Th[2]=Th[4]=Th[6]=0;
	Th[1]=Th[3]=Th[5]=(float)PI/6;

	//Getting initial position of the end effector
	convertcartesian(Pos,Th);

	k=0;
	do
	{

		/*for(i=0;i<NC;i++)
			std::cout<<Pos[i]<<"\t";
		cout<<"\n";*/
		//calculating Jacobian Matrix
		Jacobian(Th,J);
		Pinverse(J,NC, NL, Jpi);

		//calculating delta X
		for(i=0;i<(NC);i++)
		{
			delE[i]=E[i]-Pos[i];
			//delE[i]*=gain;
		}

		//calculating the small change in thehta
		for(i=0;i<NL;i++)
		{
			delTh[i]=0;
			for(j=0;j<(NC);j++)
				delTh[i]+=Jpi[i][j]*delE[j];
			Th[i]+=gain*delTh[i];
			if(Th[1]>(80*PI/180))
			Th[1]=(80*PI/180);
			//cout<<Th[1]<<"\n";
		}

		for(i=0;i<NL;i++);
	//		cout<<180*Th[i]/PI<<"\t";
	//	cout<<endl;//<<"********************"<<endl;
		//Position achieved in xyz coordinates after the motion
		convertcartesian(Pos,Th);
		k++;
	}while(k<1000);
	for(i=0;i<7;i++)cout<<Th[i]*180/PI<<endl;
	//cout<<"x="<<Pos[0]<<" y="<<Pos[1]<<" z="<<Pos[2];
	return 0;
}

