// jacobian_psuedoinverse_positioning.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include<constants.h>
#include<RealPCube.h>
#include<operations.h>
#include<winuser.h>
#include<windows.h>
#define GAIN (0.05)      //speed 
#define T_MAX (3)        // time in sec 
#define Nout (NC+NO)      // NC =3 no of cartesian translation variable.
                         // NO =3 no of angular orientations

using namespace std;
//========================================================
int _tmain(int argc, _TCHAR* argv[])
{
   uint i=0,j=0;
  float* vTh = NULL;
  vTh = allocate<float>(NL);

  RealPCube P(0);
  //==================================================================
  // HOMING THE ROBOT

  P.check_move_home();
  usleep(2);
  zero(vTh,NL);
  cout<<"Enter angles to achieve:";
  //for(i=0;i<7;i++)
  //{cin>>vTh[i];vTh[i]=DEG2RAD(vTh[i]);}
  //P.PositionKinematics(vTh,vx);  // this function gives del_x when del_th is given. its a function in PCube.h
  //==================================================================
  //MOVING THE ROBOT TO POSITION
  //cout << "Moving to  Position \n";
  //cout << "Initial angles :  ";
  //display(vTh,NL);
  
  for(i=40;i<=60;i++)
  {
	  vTh[0]=DEG2RAD(-20+(i%13));
	  vTh[1]=DEG2RAD(-10+(i%13));
	  vTh[2]=DEG2RAD(10+(i%13));
	  vTh[3]=DEG2RAD(20+(i%13));
	  vTh[4]=DEG2RAD(30+(i%13));
	  vTh[5]=DEG2RAD(20+(i%13));
	  vTh[7]=DEG2RAD(-10+(i%13));
	  vTh[8]=DEG2RAD(70+(i%13));
	  P.MovePosition(vTh);
  }
  
  vTh[0]=DEG2RAD(0);
  vTh[1]=DEG2RAD(0);
  vTh[2]=DEG2RAD(0);
  vTh[3]=DEG2RAD(0);
  vTh[4]=DEG2RAD(0);
  vTh[5]=DEG2RAD(0);
  vTh[7]=DEG2RAD(0);
  vTh[7]=DEG2RAD(0);
  P.MovePosition(vTh);
  
  // moves the hand link angles to del_Th
 /* P.read_joint_angles(vThr);    // reads the present position of the angles.
  cout << "Joint Angle reached:  ";
  display(vThr,NL);             
*/

	return 0;
}

